<script setup>
import AuthenticatedLayout from '@/Layouts/AuthenticatedLayout.vue';

import { Head, Link, useForm } from '@inertiajs/vue3';
import { showFlashMessage } from '@/global_func.js';




</script>

<template>
    <Head title="Dashboard" />

    <AuthenticatedLayout :user="user">
        <div class="container-fluid">

            <!-- Page Heading -->
            <h1 class="h3 mb-2 text-gray-800">Detail pesanan</h1>
            <p class="mb-4">Berikut ini adalah detial pesanan.</p>

            <!-- DataTales Example -->
            <div class="card border-0 mb-4">
                <div class="card-header py-3 bg-main d-flex justify-content-between align-items-center">
                    <h6 class="m-0 font-weight-bold text-white"><i class="fas fa-info-circle"></i> Informasi Pelanggan</h6>
                </div>
                <div class="card-body">
                    <table class="table table-striped">
                        <tr>
                            <td>Nama</td>
                            <td>{{ pesanan.pelanggan.nama }}</td>
                        </tr>
                        <tr>
                            <td>Instansi</td>
                            <td>{{ pesanan.pelanggan.instansi }}</td>
                        </tr>
                        <tr>
                            <td>jenis_kelamin</td>
                            <td>{{ pesanan.pelanggan.jenis_kelamin }}</td>
                        </tr>
                        <tr>
                            <td>jenis_pelanggan</td>
                            <td>{{ pesanan.pelanggan.jenis_pelanggan }}</td>
                        </tr>
                        <tr>
                            <td>email</td>
                            <td>{{ pesanan.pelanggan.email }}</td>
                        </tr>
                        <tr>
                            <td>kontak</td>
                            <td>{{ pesanan.pelanggan.telepon }}</td>
                        </tr>
                    </table>
                </div>
            </div>

            <div class="card border-0 mb-4">
                <div class="card-header py-3 bg-main d-flex justify-content-between align-items-center">
                    <h6 class="m-0 font-weight-bold text-white"><i class="fa-solid fa-boxes-stacked"></i> Barang pesanan
                    </h6>
                </div>
                <div class="card-body">
                    <table class="table">
                        <thead>
                            <tr>
                                <th>nama</th>
                                <th>deskripsi</th>
                                <th>bahan</th>
                                <th>mesin</th>
                                <th>finishing</th>
                                <th>jumlah</th>
                                <th>harga satuan</th>
                                <th>total</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="(order, index) in pesanan.produk" :key="index">
                                <td>{{ order.nama }}</td>
                                <td>{{ order.deskripsi }}</td>
                                <td>
                                    {{ order.bahan }}
                                </td>
                                <td>{{ order.mesin }}</td>
                                <td>{{ order.finishing }}</td>
                                <td>{{ order.jumlah }}</td>
                                <td>Rp. {{ Number(order.harga_satuan).toLocaleString() }}
                                </td>
                                <td>Rp. {{ Number(order.harga_satuan *
                                    order.jumlah).toLocaleString() }}</td>

                            </tr>
                        </tbody>
                    </table>
                    <h5>Total : Rp. {{ Number(total(pesanan)).toLocaleString() }}</h5>
                </div>
            </div>
            <div class="card border-0 mb-4">
                <div class="card-header py-3 bg-main d-flex justify-content-between align-items-center">
                    <h6 class="m-0 font-weight-bold text-white"><i class="fa-solid fa-wallet"></i> Pembayaran
                        <template v-if="sumJumlahYangDibayar(pesanan.pembayaran) >= total(pesanan)">
                            <span class="badge badge-success">lunas</span>
                        </template>
                        <template v-else>
                            <span class="badge badge-danger">belum lunas</span>
                        </template>
                    </h6>
                    <div>
                        <Link :href="'/pesanan/print/' + pesanan.id" class="btn btn-light mr-2"> <i
                            class="fas fa-print"></i>
                        </Link>
                        <template v-if="sumJumlahYangDibayar(pesanan.pembayaran) < total(pesanan)">

                            <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#pembayaran">
                                <i class="fas fa-plus"></i>
                            </button>
                        </template>

                    </div>
                </div>
                <div class="card-body">
                    <table class="table">
                        <thead>
                            <tr>
                                <th>Jenis pembayaran</th>
                                <th>nominal</th>
                                <th>waktu pembayaran</th>
                                <th>pengurus</th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="pembayaran in pesanan.pembayaran">
                                <td>{{ pembayaran.jenis_pembayaran == null ? 'pembayaran mendatang' :
                                    pembayaran.jenis_pembayaran }}</td>
                                <td>Rp. {{ Number(pembayaran.jumlah_yang_dibayar).toLocaleString() }}</td>
                                <td>{{ pembayaran.created_at }}</td>
                                <td>{{ pembayaran.pesanan.user.name }}</td>
                            </tr>
                        </tbody>
                    </table>

                </div>
            </div>
        </div>


        <!-- Modal -->
        <div class="modal fade" id="pembayaran" tabindex="-1" aria-labelledby="pembayaranLabel" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="pembayaranLabel">Pembayaran</h5>
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <label for="jenis_pembayaran">jenis_pembayaran</label>
                            <select v-model="selectJenisPembayaran" class="form-control" name="jenis_pembayaran"
                                id="jenis_pembayaran">
                                <option value="">-- pilih jenis pembayaran --</option>
                                <option>Cash</option>
                                <option>Transfer</option>
                                <option>Other</option>
                            </select>
                        </div>
                        <div class="form-group">
                            <label for="jumlah_yang_dibayar">jumlah_yang_dibayar</label>
                            <input v-model="inputJumlahYangDibayar" type="text" class="form-control"
                                name="jumlah_yang_dibayar" id="jumlah_yang_dibayar">
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">tutup</button>
                        <button @click="tambahPembayaran" type="button" class="btn btn-primary">Simpan</button>
                    </div>
                </div>
            </div>
        </div>


    </AuthenticatedLayout>
</template>

<script>



export default {
    data() {
        return {
            pesanan: [],

            inputJumlahYangDibayar: '',
            selectJenisPembayaran: '',

        }
    },
    props: {
        user: Object,
        pesanan: Object,
        id_pesanan: Number,
    },
    computed: {
        // Calculate total for all products in all orders

    },
    methods: {
        total(pesanan) {
            let total = 0;
            pesanan.produk.forEach(product => {
                total += product.jumlah * product.harga_satuan;
            });
            return total;
        },
        tambahPembayaran() {

            const formData = {
                jumlah_yang_dibayar: this.inputJumlahYangDibayar,
                jenis_pembayaran: this.selectJenisPembayaran,
                id_pesanan: this.id_pesanan,
            }
            // Send the data to the backend server using axios
            axios.post('/admin/pembayaran', formData)
                .then(response => {
                    // Handle success response
                    console.log(response);

                })
                .catch(error => {
                    // Handle error response
                    console.error(error);


                }).finally(() => {
                    $('#pembayaran').modal('hide');
                    showFlashMessage('Data berhasil tersimpan');
                    document.location.reload();
                });
        },
        sumJumlahYangDibayar(data) {
            if (!data || data.length === 0) {
                return 0;
            }

            return data.reduce((total, item) => total + item.jumlah_yang_dibayar, 0);
        },
        calculateSubtotal(row) {
            // Calculate subtotal for a row

            return row.jumlah * row.harga_satuan;
        },
        async fetchPesanan() {
            axios.get(`/api/get-pesanan/${this.id_pesanan}`)
                .then(response => {
                    // Update the soal data in the component
                    this.pesanan = response.data;
                    console.log(this.pesanan);
                })
                .catch(error => {
                    console.error(error);
                });

        },
    },
    mounted() {

        this.fetchPesanan();
        // Initialize DataTables
        $('#dataTable').DataTable({
            // DataTables configuration options
        });
    }
}
</script>
